{{ ansible_managed | comment }}
# https://snuffleupagus.readthedocs.io/config.html

# known issues with misp
# FIXME! cakephp is making this very hard...
# sp.global_strict.enable();
# FIXME!
#   PHP Warning:  Illegal string offset 'LC_MESSAGES' in /var/www/MISP/app/Lib/cakephp/lib/Cake/I18n/I18n.php on line 448
#   PHP Notice:  Array to string conversion in /var/www/MISP/app/Lib/cakephp/lib/Cake/I18n/I18n.php on line 448
#   PHP Notice:  Undefined variable: baseurl in /var/www/MISP/app/View/Layouts/default.ctp on line 98
#sp.sloppy_comparison.enable();
# FIXME! PHP Fatal error:  [snuffleupagus][unserialize] Invalid HMAC for a:99:{s:9:"Configure";s:57:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Core/Configure.php";s:4:"Hash";s:55:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Utility/Hash.php";s:5:"Cache";s:54:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Cache/Cache.php";s:10:"FileEngine";s:66:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Cache/Engine/FileEngine.php";s:11:"CacheEngine";s:60:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Cache/CacheEngine.php";s:9:"Inflector";s:60:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Utility/Inflector.php";s:12:"ErrorHandler";s:61:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Error/ErrorHandler.php";s:9:"PhpReader";s:62:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Configure/PhpReader.php";s:21:"ConfigReaderInterface";s:74:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Configure/ConfigReaderInterface.php";s:10:"CakePlugin";s:58:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Core/CakePlugin.php";s:7:"CakeLog";s:54:"/var/www/MISP/app/Lib/cakephp/lib/Cake/Log/CakeLog.php";s:19:"LogEngineCollection";s:66:"/ in /var/www/MISP/app/Lib/cakephp/lib/Cake/Cache/Engine/FileEngine.php on line 194
#sp.unserialize_hmac.enable();
# FIXME! PHP Fatal error:  [snuffleupagus][readonly_exec] Attempted execution of a writable file (/var/www/MISP/app/Config/config.php). in /var/www/MISP/app/Lib/cakephp/lib/Cake/Configure/PhpReader.php on line 72
#sp.readonly_exec.enable();
## simulation mode
# FIXME! PHP Fatal error:  [snuffleupagus][unserialize] The serialized object is too small. in /var/www/MISP/app/Lib/cakephp/lib/Cake/Cache/Engine/FileEngine.php on line 194
#sp.unserialize_hmac.simulation().enable();
## those seems to create issues with apache2 start
#sp.global_strict.simulation().enable();
#sp.sloppy_comparison.simulation().enable();
#sp.readonly_exec.simulation().enable();

sp.global.secret_key("{{ snuffleupagus_secret1.stdout | default(snuffleupagus_secret2.stdout) }}");
sp.harden_random.enable();
sp.disable_xxe.enable();
sp.eval_blacklist.list("system,exec,shell_exec");
sp.eval_whitelist.list("strlen,strcmp").simulation();

# use SameSite on session cookie
sp.cookie.name("PHPSESSID").samesite("lax");

# Harden the `chmod` function
# Note: checked against Cake Cache::config mask
# Harden the `chmod` function (0777 (oct = 511, 0666 = 438)
sp.disable_function.function("chmod").param("permissions").value("438").drop();
sp.disable_function.function("chmod").param("permissions").value("511").drop();
sp.disable_function.function("chmod").param("mode").value_r("^[0-9]{2}[7]$").drop();

# Prevent various `mail`-related vulnerabilities
sp.disable_function.function("mail").param("additional_parameters").value_r("\\-").drop();

# Since it's now burned, me might as well mitigate it publicly
sp.disable_function.function("putenv").param("setting").value_r("LD_").drop()

##Prevent various `include`-related vulnerabilities
sp.disable_function.function("require_once").value_r("\.(inc|phtml|php)$").allow();
sp.disable_function.function("include_once").value_r("\.(inc|phtml|php)$").allow();
sp.disable_function.function("require").value_r("\.(inc|phtml|php)$").allow();
sp.disable_function.function("include").value_r("\.(inc|phtml|php|ctp)$").allow();
sp.disable_function.function("require_once").drop()
sp.disable_function.function("include_once").drop()
sp.disable_function.function("require").drop()
sp.disable_function.function("include").drop()

# Prevent `system`-related injections
sp.disable_function.function("system").param("command").value_r("[$|;&`\\n]").drop();
sp.disable_function.function("shell_exec").param("command").value_r("[$|;&`\\n]").drop();
sp.disable_function.function("exec").param("command").value_r("[$|;&`\\n]").drop();
sp.disable_function.function("proc_open").param("command").value_r("[$|;&`\\n]").drop();

# Prevent runtime modification of interesting things
sp.disable_function.function("ini_set").param("var_name").value("assert.active").drop();
sp.disable_function.function("ini_set").param("var_name").value("zend.assertions").drop();
sp.disable_function.function("ini_set").param("var_name").value("memory_limit").drop();
sp.disable_function.function("ini_set").param("var_name").value("include_path").drop();
sp.disable_function.function("ini_set").param("var_name").value("open_basedir").drop();

# Detect some backdoors via environment recon
sp.disable_function.function("ini_get").param("var_name").value("allow_url_fopen").drop();
sp.disable_function.function("ini_get").param("var_name").value("open_basedir").drop();
sp.disable_function.function("ini_get").param("var_name").value_r("suhosin").drop();
sp.disable_function.function("function_exists").param("function_name").value("eval").drop();
sp.disable_function.function("function_exists").param("function_name").value("exec").drop();
sp.disable_function.function("function_exists").param("function_name").value("system").drop();
sp.disable_function.function("function_exists").param("function_name").value("shell_exec").drop();
sp.disable_function.function("function_exists").param("function_name").value("proc_open").drop();
sp.disable_function.function("function_exists").param("function_name").value("passthru").drop();
sp.disable_function.function("is_callable").param("var").value("eval").drop();
sp.disable_function.function("is_callable").param("var").value("exec").drop();
sp.disable_function.function("is_callable").param("var").value("system").drop();
sp.disable_function.function("is_callable").param("var").value("shell_exec").drop();
sp.disable_function.function("is_callable").param("var").value("proc_open").drop();
sp.disable_function.function("is_callable").param("var").value("passthru").drop();

# File upload
sp.disable_function.function("move_uploaded_file").param("destination").value_r("\\.ph").drop();
sp.disable_function.function("move_uploaded_file").param("destination").value_r("\\.ht").drop();
